#include <windows.h>
#include <stdio.h>

char* Dir1 = "c:\\temp";
char* Dir2 = "c:\\Winnt";

//my header files are old!
int (__stdcall *ReadDirectoryChangesW) (HANDLE, LPVOID, DWORD, BOOL, DWORD, LPDWORD,LPOVERLAPPED,LPOVERLAPPED_COMPLETION_ROUTINE);

								  
//cheesy unicode to ascii conversion -> assumes buf sufficient length
void Convert(char* buf, char* wBuf, int wLen){
	
	int j=0;

	for(int i=0; i<wLen;i++){
		if(wBuf[i] != 0){
			buf[j++] =  wBuf[i];
		}
	}
	
} 
		

//this base function is taken from MFC example:
// Spying a File System - Vitali Halershtein - April 29, 2004 
//  http://www.codeguru.com/Cpp/controls/listview/data/print.php/c4467
DWORD WINAPI ThreadHandler(void* dirPointer){

	
  printf("New thread Started to watch %s\n", dirPointer);

  FILE_NOTIFY_INFORMATION Buffer[1024];
  DWORD BytesReturned;

  
  HANDLE hDir = CreateFile(
				(const char*)dirPointer,             // pointer to the file name
				FILE_LIST_DIRECTORY,                // access (read/write) mode
				FILE_SHARE_READ|FILE_SHARE_DELETE,  // share mode
				NULL,                               // security descriptor
				OPEN_EXISTING,                      // how to create
				FILE_FLAG_BACKUP_SEMANTICS,         // file attributes
				NULL );                             // file with attributes to copy

  
  while( ReadDirectoryChangesW(
            hDir,                         // handle to directory
            &Buffer,                      // read results buffer
            sizeof(Buffer),               // length of buffer
            TRUE,                         // monitoring option
            FILE_NOTIFY_CHANGE_FILE_NAME, // filter conditions
            &BytesReturned,               // bytes returned
            NULL,                         // overlapped buffer
            NULL						  // completion routine
            ))
    {
	
		int i=0;
		char buf[MAX_PATH];
		char action[30];

		do{
			  memset(buf,0,MAX_PATH);
			  Convert(buf, (char*)Buffer[i].FileName, Buffer[i].FileNameLength); 
			  
			  switch(Buffer[i].Action){
				  case FILE_ACTION_ADDED:			 strcpy(action,"Created: ");  break; 
				  case FILE_ACTION_REMOVED:			 strcpy(action,"Deteled: ");  break; 
				  case FILE_ACTION_MODIFIED:		 strcpy(action,"Modifed: ");  break; 
				  case FILE_ACTION_RENAMED_OLD_NAME: strcpy(action,"Renamed: ");  break; 
				  case FILE_ACTION_RENAMED_NEW_NAME: strcpy(action,"Renamed: ");  break;
			  }
			   
			  printf("%s%s\\%s\n", action, dirPointer, buf);
			  i++;	  
		}
		while (!Buffer[i].NextEntryOffset);
	}

	return 1;

}

void main(void){
	
	unsigned long threadID;

	HINSTANCE h = LoadLibrary("kernel32.dll");
	GetProcAddress( h, "ReadDirectoryChangesW");
	
	_asm mov ReadDirectoryChangesW, eax //lazy no long cast

	if( (int)ReadDirectoryChangesW == 0 ){
		printf("Could not Get pointer to ReadDirectoryChangesW!");
		return;
	}

	printf("Initilizing Threads\n");
	
	CreateThread(NULL,0, ThreadHandler, Dir1,0,&threadID);
	printf("Created thread id: %x\n", threadID);

	CreateThread(NULL,0, ThreadHandler, Dir2,0,&threadID);
	printf("Created thread id: %x\n", threadID);

	printf("Pausing main thread to wait for results.\n");
	printf("Press CTRL-C to terminate.\n\n");

	while(1){
		Sleep(10);
	}

}